Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/Placeholder.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 5177)
@@ -50,9 +50,9 @@
     }
 
-    public override IOperation Apply() {
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      OperationCollection next = new OperationCollection(base.Apply(context));
       IOperator op = OperatorParameter.ActualValue;
       if (op != null)
-        next.Insert(0, ExecutionContext.CreateOperation(op));
+        next.Insert(0, context.CreateOperation(op));
       return next;
     }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/ScopeCleaner.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 5177)
@@ -53,8 +53,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       CurrentScope.Variables.Clear();
       CurrentScope.SubScopes.Clear();
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 5177)
@@ -50,7 +50,7 @@
     }
     
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Successor != null)
-        return ExecutionContext.CreateOperation(Successor);
+        return context.CreateOperation(Successor);
       else
         return null;
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticBranch.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticBranch.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticBranch.cs	(revision 5177)
@@ -71,10 +71,10 @@
     }
 
-    public override IOperation Apply() {
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (RandomParameter.ActualValue.NextDouble() < ProbabilityParameter.ActualValue.Value) {
-        if (FirstBranch != null) next.Insert(0, ExecutionContext.CreateOperation(FirstBranch));
+        if (FirstBranch != null) next.Insert(0, context.CreateOperation(FirstBranch));
       } else {
-        if (SecondBranch != null) next.Insert(0, ExecutionContext.CreateOperation(SecondBranch));
+        if (SecondBranch != null) next.Insert(0, context.CreateOperation(SecondBranch));
       }
       return next;
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs	(revision 5177)
@@ -109,5 +109,5 @@
     /// or all selected operators have zero probabitlity.</exception>
     /// <returns>A new operation with the operator that was selected followed by the current operator's successor.</returns>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IRandom random = RandomParameter.ActualValue;
       DoubleArray probabilities = ProbabilitiesParameter.ActualValue;
@@ -131,9 +131,9 @@
         }
       }
-      OperationCollection next = new OperationCollection(base.Apply());
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (successor != null) {
         if (CreateChildOperation)
-          next.Insert(0, ExecutionContext.CreateChildOperation(successor));
-        else next.Insert(0, ExecutionContext.CreateOperation(successor));
+          next.Insert(0, context.CreateChildOperation(successor));
+        else next.Insert(0, context.CreateOperation(successor));
       }
       return next;
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesCreator.cs	(revision 5177)
@@ -58,9 +58,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int n = NumberOfSubScopesParameter.ActualValue.Value;
       for (int i = 0; i < n; i++)
         CurrentScope.SubScopes.Add(new Scope(i.ToString()));
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesMixer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesMixer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesMixer.cs	(revision 5177)
@@ -77,7 +77,7 @@
     /// <param name="scope">The scope whose sub scopes should be mixed.</param>
     /// <returns><c>null</c>.</returns>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int partitions = Partitions.Value;
-      IScope scope = ExecutionContext.Scope;
+      IScope scope = context.Scope;
       int count = scope.SubScopes.Count;
       if ((count % partitions) != 0)
@@ -96,5 +96,5 @@
       scope.SubScopes.AddRange(reorderedSubScopes);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesProcessor.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesProcessor.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesProcessor.cs	(revision 5177)
@@ -67,7 +67,7 @@
     }
 
-    public override IOperation Apply() {
-      List<IScope> scopes = GetScopesOnLevel(ExecutionContext.Scope, Depth.Value).ToList();
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      List<IScope> scopes = GetScopesOnLevel(context.Scope, Depth.Value).ToList();
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (scopes.Count != Operators.Count)
         throw new ArgumentException("The number of operators doesn't match the number of sub-scopes at depth " + Depth.Value);
@@ -75,5 +75,5 @@
       inner.Parallel = Parallel == null ? false : Parallel.Value;
       for (int i = 0; i < scopes.Count(); i++) {
-        inner.Add(ExecutionContext.CreateOperation(Operators[i], scopes[i]));
+        inner.Add(context.CreateOperation(Operators[i], scopes[i]));
       }
       next.Insert(0, inner);
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesRemover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesRemover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesRemover.cs	(revision 5177)
@@ -67,5 +67,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (RemoveAllSubScopes)
         CurrentScope.SubScopes.Clear();
@@ -73,5 +73,5 @@
         CurrentScope.SubScopes.RemoveAt(SubScopeIndexParameter.ActualValue.Value);
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesSorter.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesSorter.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/SubScopesSorter.cs	(revision 5177)
@@ -65,9 +65,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       descending = DescendingParameter.ActualValue.Value;
       actualName = ValueParameter.TranslatedName;
       CurrentScope.SubScopes.Sort(SortScopes);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/UniformSubScopesProcessor.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/UniformSubScopesProcessor.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/UniformSubScopesProcessor.cs	(revision 5177)
@@ -74,12 +74,12 @@
     }
 
-    public override IOperation Apply() {
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (Operator != null) {
-        List<IScope> scopes = GetScopesOnLevel(ExecutionContext.Scope, Depth.Value).ToList();
+        List<IScope> scopes = GetScopesOnLevel(context.Scope, Depth.Value).ToList();
         OperationCollection inner = new OperationCollection();
         inner.Parallel = Parallel == null ? false : Parallel.Value;
         for (int i = 0; i < scopes.Count; i++) {
-          inner.Add(ExecutionContext.CreateOperation(Operator, scopes[i]));
+          inner.Add(context.CreateOperation(Operator, scopes[i]));
         }
         next.Insert(0, inner);
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/VariableCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/VariableCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/VariableCreator.cs	(revision 5177)
@@ -53,5 +53,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IVariable var;
       foreach (IParameter param in CollectedValues) {
@@ -66,5 +66,5 @@
           CurrentScope.Variables.Add(new Variable(name, param.Description, value == null ? null : (IItem)value.Clone()));
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ChildrenCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ChildrenCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ChildrenCreator.cs	(revision 5177)
@@ -67,5 +67,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int parentsPerChild = ParentsPerChildParameter.ActualValue.Value;
       int parents = CurrentScope.SubScopes.Count;
@@ -82,5 +82,5 @@
         CurrentScope.SubScopes.Add(child);
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/DiscreteDoubleValueModifier.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/DiscreteDoubleValueModifier.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/DiscreteDoubleValueModifier.cs	(revision 5177)
@@ -95,5 +95,5 @@
     /// </remarks>
     /// <returns>What the base class returns.</returns>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int index = IndexParameter.ActualValue.Value, startIndex = StartIndexParameter.ActualValue.Value;
       if (index >= startIndex) {
@@ -115,5 +115,5 @@
         value.Value = newValue;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs	(revision 5177)
@@ -56,5 +56,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<IntValue> ranks = RankParameter.ActualValue;
       ItemArray<DoubleValue> distances = CrowdingDistanceParameter.ActualValue;
@@ -62,9 +62,9 @@
       int[] indices = Enumerable.Range(0, size).ToArray();
 
-      IScope[] scopes = ExecutionContext.Scope.SubScopes.ToArray();
+      IScope[] scopes = context.Scope.SubScopes.ToArray();
       Array.Sort(indices, scopes, new CustomComparer(ranks, distances));
-      ExecutionContext.Scope.SubScopes.Clear();
-      ExecutionContext.Scope.SubScopes.AddRange(scopes);
-      return base.Apply();
+      context.Scope.SubScopes.Clear();
+      context.Scope.SubScopes.AddRange(scopes);
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 5177)
@@ -78,5 +78,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleArray[] qualities = QualitiesParameter.ActualValue.ToArray();
       int populationSize = qualities.Length;
@@ -89,5 +89,5 @@
       Apply(qualities, distances);
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs	(revision 5177)
@@ -61,10 +61,10 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       BoolArray maximization = MaximizationParameter.ActualValue;
       ItemArray<DoubleArray> qualities = QualitiesParameter.ActualValue;
       if (qualities == null) throw new InvalidOperationException(Name + ": No qualities found.");
 
-      IScope scope = ExecutionContext.Scope;
+      IScope scope = context.Scope;
       int populationSize = scope.SubScopes.Count;
 
@@ -131,5 +131,5 @@
           scope.SubScopes.Add(frontScope);
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ParentCopyCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ParentCopyCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ParentCopyCrossover.cs	(revision 5177)
@@ -43,6 +43,6 @@
     }
 
-    public override IOperation Apply() {
-      IScope scope = ExecutionContext.Scope;
+    public override IOperation Apply(IExecutionContext context) {
+      IScope scope = context.Scope;
       int index = RandomParameter.ActualValue.Next(scope.SubScopes.Count);
       IScope child = scope.SubScopes[index];
@@ -51,5 +51,5 @@
         scope.Variables.Add((IVariable)var.Clone());
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/QualityComparator.cs	(revision 5177)
@@ -59,5 +59,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleValue left = LeftSideParameter.ActualValue;
       DoubleValue right = RightSideParameter.ActualValue;
@@ -67,5 +67,5 @@
         ResultParameter.ActualValue = new BoolValue(better);
       else ResultParameter.ActualValue.Value = better;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ResultsCollector.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ResultsCollector.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/ResultsCollector.cs	(revision 5177)
@@ -60,5 +60,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       bool copy = CopyValueParameter.Value.Value;
       ResultCollection results = ResultsParameter.ActualValue;
@@ -84,5 +84,5 @@
         }
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SASEGASAReunificator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SASEGASAReunificator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SASEGASAReunificator.cs	(revision 5177)
@@ -61,6 +61,6 @@
     /// <param name="scope">The current scope whose sub scopes to reduce.</param>
     /// <returns><c>null</c>.</returns>
-    public override IOperation Apply() {
-      IScope scope = ExecutionContext.Scope;
+    public override IOperation Apply(IExecutionContext context) {
+      IScope scope = context.Scope;
       if (VillageCountParameter.ActualValue == null) VillageCountParameter.ActualValue = new IntValue(scope.SubScopes.Count);
       int villageCount = VillageCountParameter.ActualValue.Value;
@@ -92,5 +92,5 @@
       VillageCountParameter.ActualValue.Value = villageCount;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SolutionsCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SolutionsCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/SolutionsCreator.cs	(revision 5177)
@@ -69,5 +69,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int count = NumberOfSolutionsParameter.ActualValue.Value;
       IOperator creator = SolutionCreatorParameter.ActualValue;
@@ -80,8 +80,8 @@
       OperationCollection next = new OperationCollection();
       for (int i = 0; i < count; i++) {
-        if (creator != null) next.Add(ExecutionContext.CreateOperation(creator, CurrentScope.SubScopes[current + i]));
-        if (evaluator != null) next.Add(ExecutionContext.CreateOperation(evaluator, CurrentScope.SubScopes[current + i]));
+        if (creator != null) next.Add(context.CreateOperation(creator, CurrentScope.SubScopes[current + i]));
+        if (evaluator != null) next.Add(context.CreateOperation(evaluator, CurrentScope.SubScopes[current + i]));
       }
-      next.Add(base.Apply());
+      next.Add(base.Apply(context));
       return next;
     }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/TabuMaker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/TabuMaker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/TabuMaker.cs	(revision 5177)
@@ -62,5 +62,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       int tabuTenure = TabuTenureParameter.ActualValue.Value;
@@ -75,5 +75,5 @@
 
       tabuList.Add(GetTabuAttribute(MaximizationParameter.ActualValue.Value, QualityParameter.ActualValue.Value, MoveQualityParameter.ActualValue.Value));
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs	(revision 5177)
@@ -55,6 +55,6 @@
     /// </summary>
     /// <returns>The next operation.</returns>
-    public override IOperation Apply() {
-      IScope scope = ExecutionContext.Scope;
+    public override IOperation Apply(IExecutionContext context) {
+      IScope scope = context.Scope;
       List<IScope> emigrantsList = new List<IScope>();
 
@@ -72,5 +72,5 @@
         scope.SubScopes[i].SubScopes.Add(emigrantsList[i]);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UserDefinedOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UserDefinedOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/UserDefinedOperator.cs	(revision 5177)
@@ -35,10 +35,10 @@
     public UserDefinedOperator() : base() { }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       OperationCollection result = new OperationCollection();
       foreach (IOperator op in Operators.CheckedItems.OrderBy(x => x.Index).Select(x => x.Value)) {
-        result.Add(ExecutionContext.CreateOperation(op));
+        result.Add(context.CreateOperation(op));
       }
-      result.Add(base.Apply());
+      result.Add(base.Apply(context));
       return result;
     }
Index: /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/WeightedParentsQualityComparator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/WeightedParentsQualityComparator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Optimization.Operators/3.3/WeightedParentsQualityComparator.cs	(revision 5177)
@@ -66,5 +66,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleValue> rightQualities = RightSideParameter.ActualValue;
       if (rightQualities.Length < 1) throw new InvalidOperationException(Name + ": No subscopes found.");
@@ -122,5 +122,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Analyzers/BestAntTrailAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Analyzers/BestAntTrailAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Analyzers/BestAntTrailAnalyzer.cs	(revision 5177)
@@ -75,5 +75,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<SymbolicExpressionTree> expressions = SymbolicExpressionTreeParameter.ActualValue;
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
@@ -95,5 +95,5 @@
         results["Best Artificial Ant Solution"].Value = antTrail;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Evaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Evaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.ArtificialAnt/3.3/Evaluator.cs	(revision 5177)
@@ -60,5 +60,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       SymbolicExpressionTree expression = SymbolicExpressionTreeParameter.ActualValue;
       BoolMatrix world = WorldParameter.ActualValue;
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/Analyzer/ValidationBestSymbolicClassificationSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/Analyzer/ValidationBestSymbolicClassificationSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/Analyzer/ValidationBestSymbolicClassificationSolutionAnalyzer.cs	(revision 5177)
@@ -214,5 +214,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       var trees = SymbolicExpressionTree;
       string targetVariable = ClassificationProblemData.TargetVariable.Value;
@@ -234,5 +234,5 @@
 
       foreach (var tree in trees) {
-        double quality = Evaluator.Evaluate(SymbolicExpressionTreeInterpreter, tree,
+        double quality = Evaluator.Evaluate(context, SymbolicExpressionTreeInterpreter, tree,
           lowerEstimationLimit, upperEstimationLimit, ClassificationProblemData.Dataset,
           targetVariable, rows);
@@ -274,5 +274,5 @@
         UpdateBestSolutionResults();
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Analyzers/RegressionSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Analyzers/RegressionSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Analyzers/RegressionSolutionAnalyzer.cs	(revision 5177)
@@ -113,5 +113,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleValue prevBestSolutionQuality = BestSolutionQualityParameter.ActualValue;
       var bestSolution = UpdateBestSolution();
@@ -120,5 +120,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/LinearRegression/LinearRegressionSolutionCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/LinearRegression/LinearRegressionSolutionCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/LinearRegression/LinearRegressionSolutionCreator.cs	(revision 5177)
@@ -95,8 +95,8 @@
 
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       double rmsError, cvRmsError;
       SymbolicExpressionTree = CreateSymbolicExpressionTree(DataAnalysisProblemData.Dataset, DataAnalysisProblemData.TargetVariable.Value, DataAnalysisProblemData.InputVariables.CheckedItems.Select(x => x.Value.Value), SamplesStart.Value, SamplesEnd.Value, out rmsError, out cvRmsError);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs	(revision 5177)
@@ -206,5 +206,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       var trees = SymbolicExpressionTree;
 
@@ -227,5 +227,5 @@
 
       foreach (var tree in trees) {
-        double quality = Evaluator.Evaluate(SymbolicExpressionTreeInterpreter, tree,
+        double quality = Evaluator.Evaluate(context, SymbolicExpressionTreeInterpreter, tree,
           lowerEstimationLimit, upperEstimationLimit,
           ProblemData.Dataset, targetVariable,
@@ -278,5 +278,5 @@
       AddValue(validationValues, BestSolutionQualityParameter.ActualValue.Value, BestSolutionQualityParameterName, BestSolutionQualityParameterName);
       AddValue(validationValues, bestQuality, CurrentBestValidationQualityParameterName, CurrentBestValidationQualityParameterName);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionModelQualityAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionModelQualityAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionModelQualityAnalyzer.cs	(revision 5177)
@@ -139,9 +139,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       Analyze(SymbolicExpressionTreeParameter.ActualValue, SymbolicExpressionTreeInterpreterParameter.ActualValue,
         UpperEstimationLimit.Value, LowerEstimationLimit.Value, ProblemDataParameter.ActualValue,
         ResultsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
